From 7b2c8bfb068ab2890f477eee7a39eb4256e82679 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 19:01:13 +0000
Subject: [PATCH 1273/2232] Merge pull request #419 from dtolnay/deps


Track include_prefix and links attribute across deps
---

diff --git a/gen/build/src/deps.rs b/gen/build/src/deps.rs
index 6e177c9..c585203 100644
--- a/gen/build/src/deps.rs
+++ b/gen/build/src/deps.rs
@@ -1,15 +1,24 @@
 use std::collections::BTreeMap;
 use std::env;
+use std::ffi::OsString;
 use std::path::PathBuf;
 
 #[derive(Default)]
 pub struct Crate {
+    pub include_prefix: Option<PathBuf>,
+    pub links: Option<OsString>,
     pub crate_dir: Option<PathBuf>,
     pub include_dir: Option<PathBuf>,
 }
 
 impl Crate {
     pub fn print_to_cargo(&self) {
+        if let Some(include_prefix) = &self.include_prefix {
+            println!("cargo:CXXBRIDGE_PREFIX={}", include_prefix.to_string_lossy());
+        }
+        if let Some(links) = &self.links {
+            println!("cargo:CXXBRIDGE_LINKS={}", links.to_string_lossy());
+        }
         if let Some(crate_dir) = &self.crate_dir {
             println!("cargo:CXXBRIDGE_CRATE={}", crate_dir.to_string_lossy());
         }
@@ -40,7 +49,13 @@ pub fn direct_dependencies() -> Vec<Crate> {
         //   - https://doc.rust-lang.org/cargo/reference/build-scripts.html#the-links-manifest-key
         //   - https://doc.rust-lang.org/cargo/reference/build-script-examples.html#using-another-sys-crate
         if k.starts_with("DEP_") {
-            if k.ends_with("_CXXBRIDGE_CRATE") {
+            if k.ends_with("_CXXBRIDGE_PREFIX") {
+                k.truncate(k.len() - "_CXXBRIDGE_PREFIX".len());
+                crates.entry(k).or_default().include_prefix = Some(PathBuf::from(v));
+            } else if k.ends_with("_CXXBRIDGE_LINKS") {
+                k.truncate(k.len() - "_CXXBRIDGE_LINKS".len());
+                crates.entry(k).or_default().links = Some(v);
+            } else if k.ends_with("_CXXBRIDGE_CRATE") {
                 k.truncate(k.len() - "_CXXBRIDGE_CRATE".len());
                 crates.entry(k).or_default().crate_dir = Some(PathBuf::from(v));
             } else if k.ends_with("_CXXBRIDGE_INCLUDE") {
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index ed820d4..2ec45e0 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -181,6 +181,8 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
     let crate_dir = make_crate_dir(prj);
     let include_dir = make_include_dir(prj)?;
     let this_crate = Crate {
+        include_prefix: Some(prj.include_prefix.clone()),
+        links: env::var_os("CARGO_MANIFEST_LINKS"),
         crate_dir,
         include_dir: Some(include_dir),
     };

